#Author : Wikii

#Date : 20090415
#Version : 2.00

#Date : 20081218
#Version : 1.00



$KCODE="n"
#-----------------------------------------------------------------------------
require 'sketchup.rb'
#-----------------------------------------------------------------------------
class EdgeDrive
   def initialize
      @edge=nil
      @base=nil
      @ip = nil
      @ip1= nil
      @pick=nil
      @ss=Sketchup.active_model.selection
      @ss.clear
      @ee=Sketchup.active_model.active_entities
   end
   def activate
      @ip = Sketchup::InputPoint.new
      @ip1 = Sketchup::InputPoint.new
      @ss=Sketchup.active_model.selection
      @ss.clear
      @ee=Sketchup.active_model.active_entities
       Sketchup.set_status_text "请 选择一条边线 或者 拖选两条边线 后输入尺寸",SB_PROMPT
   end
   def deactivate(view)
      view.invalidate if @drawn
   end
   def extend_edge edge,base,length
      if length.class==String #and  %w{+ -}.include?(length[0,1])
         length=edge.length.to_mm+length.to_f
      end
      other=edge.other_vertex base
      v=base.position - other.position
      v.length=length.mm.to_l-edge.length
      t= Geom::Transformation.translation v
      @ee.transform_entities( t,base.faces-edge.faces)
   end

   def move_edge edge,edge1,ver,length
      if length.class==String #and  %w{+ -}.include?(length[0,1])
         length=edge.length.to_mm+length.to_f
      end

      v=ver
      v.length=length.mm.to_l-v.length
      t= Geom::Transformation.translation v
      @ee.transform_entities( t,edge.faces-edge1.faces)
   end


   def onMouseMove(flags, x, y, view)
	   if @pick and @down
      @ip1.pick view, x, y
      if @ip1.edge and @pick and  @ip1.edge!=@pick and [0,Math::PI].include?(@ip1.edge.line[1].angle_between(@pick.line[1])) and (@ip1.edge.faces&@pick.faces).length>0
         @edge1=@ip1.edge
         @ves=ve_betweent_2line(@pick.line,@edge1.line)
         Sketchup.set_status_text "距离",SB_VCB_LABEL
         Sketchup.set_status_text @ves.length.to_mm.to_s,SB_VCB_VALUE
         @ss.add @edge
         view.invalidate
      end
      end
   end
   def draw(view)
      if (!@ves)
         view.line_width= 10
         view.drawing_color= "red"
         view.draw_lines  @edge.other_vertex( @base).position,@base.position, 3, 6, "green" if @base
         view.draw_points @base.position, 10, 1, "green" if @base
      else
         view.line_width= 10
         view.drawing_color= "red"
         view.draw_lines  @edge1.start.position,@edge1.end.position, 3, 6, "green" 
         view.drawing_color= "green"
         view.draw_lines  @pick.start.position,@pick.end.position, 3, 6, "green" 
 end
 Sketchup.set_status_text "请 选择一条边线 或者 拖选两条边线 后输入尺寸。",SB_PROMPT
 
   end

   # The onLButtonDOwn method is called when the user presses the left mouse button.
   def onLButtonDown(flags, x, y, view)
      @ip.pick view, x, y
      @down=true
      if @ip.edge
         @pick=@ip.edge
         @edge=@ip.edge
         @ip.position
         @base=@edge.vertices.sort{|x,y| (x.position-@ip.position).length<=>(y.position-@ip.position).length}[0]
         Sketchup.set_status_text "长度",SB_VCB_LABEL
         Sketchup.set_status_text @edge.length.to_mm.to_s,SB_VCB_VALUE
         @ss.clear
         @ss.add @edge
         @ves=nil
      else
         @pick=nil
      end
   end

   def  ve_betweent_2line(l1,l2)
      point = Geom.intersect_line_plane l1, l2
      point-l2[0]
   end
   # The onLButtonUp method is called when the user releases the left mouse button.
   def onLButtonUp(flags, x, y, view)
      # If we are doing a drag, then create the line on the mouse up event
      @down=nil
      @ip1.pick view, x, y
      if @ip1.edge and @pick and  @ip1.edge!=@pick and [0,Math::PI].include?(@ip1.edge.line[1].angle_between(@pick.line[1])) and (@ip1.edge.faces&@pick.faces).length>0
         @edge1=@ip1.edge
         @ves=ve_betweent_2line(@pick.line,@edge1.line)
         Sketchup.set_status_text "距离",SB_VCB_LABEL
         Sketchup.set_status_text @ves.length.to_mm.to_s,SB_VCB_VALUE
         @ss.add @edge
         @base=nil
      else
         @pick=nil
         @ves=nil
      end
      view.invalidate
   end

   def onKeyDown(key, repeat, flags, view)

   end


   def onKeyUp(key, repeat, flags, view)

   end

   def onUserText text, view
      if @edge and @base and !@ves
         length= %w{+ -}.include?(text[0,1]) ? @edge.length.to_mm+text.to_f : text.to_f
         extend_edge @edge,@base,length
         Sketchup.set_status_text "长度",SB_VCB_LABEL
         Sketchup.set_status_text @edge.length.to_mm.to_s,SB_VCB_VALUE
         view.invalidate
      end
      if @pick and @edge1 and @ves
         length= %w{+ -}.include?(text[0,1]) ? @edge.length.to_mm+text.to_f : text.to_f
         move_edge @pick,@edge1,@ves,length
         @ves=ve_betweent_2line(@pick.line,@edge1.line)
         Sketchup.set_status_text "距离",SB_VCB_LABEL
         Sketchup.set_status_text @ves.length.to_mm.to_s,SB_VCB_VALUE
         view.invalidate
      end

   end

   # onCancel is called when the user hits the escape key
   def onCancel(flag, view)
      self.reset(view)
   end


   # The following methods are not directly called from SketchUp.  They are
   # internal methods that are used to support the other methods in this class.

   # Reset the tool back to its initial state
   def reset(view)
      if( view )
         view.tooltip = nil
      end
   end
end #class
#-----------------------------------------------------------------------------
# This functions is just a shortcut for selecting the new tool
#~ Sketchup.active_model.select_tool ExtendFaceEdge.new
if !$sut
	if( not file_loaded?("EdgeDrive.rb") )
main_menu = UI.menu("Plugins")
main_menu.add_item("EdgeDrive") {(Sketchup.active_model.select_tool EdgeDrive.new)}
end
file_loaded("EdgeDrive.rb")
end

