#wikii
require "sketchup.rb"

class Fillet
   #激活代码
   def check
      @selection.each{|i| @selection.remove i if i.typename != "Edge"}
      return [nil,"PLZ select two edges!"] if @selection.length != 2
      return [nil,"PLZ select two edges!"] if @selection[0].typename != "Edge"
      return [nil,"PLZ select two edges!"] if @selection[1].typename != "Edge"
      @point = Geom.intersect_line_line @selection[0].line, @selection[1].line
      return [nil,"No intersection!"] if not @point
      return [true,@point]
   end

   def activate
      @rad=nil
      @model=Sketchup.active_model
      @selection=@model.selection
      @ents=Sketchup.active_model.entities
      if not check[0] then
         UI.messagebox "Error, #{check[1]}" , MB_OK, "Error"
         Sketchup.active_model.select_tool nil
      else
         #UI.messagebox "Point, #{check[1]}" , MB_OK, "Con"
      end
      @ed1=@selection[0]
      @face= @ed1.faces
      puts @face
      @ed2=@selection[1]
      @model.start_operation  "Fillet"
      onUserText(0,1)
   end

   def fillet (po,v1,v2,rd)
      v3=Geom::Vector3d.linear_combination 0.5, v1.normalize, 0.5, v2.normalize
      len5= (rd / Math.sin(v2.angle_between(v1) / 2))
      len4= (rd / Math.tan(v2.angle_between(v1) / 2))
      v1.length=len4
      v2.length=len4
      v3.length=len5

      p1=po.offset v1
      p2=po.offset v2
      p3=po.offset v3

      @arc=@ents.add_arc( p3, v3.reverse , v1*v2, rd, v3.angle_between(p3-p1), v3.angle_between(p3-p1)*-1,12)
      [p1,p2]
   end

   def deactivate(view)
      @model.commit_operation
   end


   def onRButtonDown(flags, x, y, view)
      Sketchup.active_model.select_tool nil
   end


   def onUserText(text, view)
      begin
         @rad=text.to_l
      rescue
         @rad=nil
      end

      if @fillet then
         @ents.erase_entities @arc if @arc
      end
      if @rad then
         e1=@ed1.vertices.sort_by{|i| i.position.distance @point}.reverse[0].position
         v1=e1 - @point
         e2=@ed2.vertices.sort_by{|i| i.position.distance @point}.reverse[0].position
         v2=e2 - @point
         @ents= @ed1.parent.entities
         @ents.erase_entities @ed1,@ed2

         if @rad != 0 then
            pts=self.fillet(@point, v1, v2,@rad)
         else
            pts=[@point,@point]
            @arc=nil
         end
         @ed1=(@ents.add_edges pts[0],e1)[0]
         @ed2=(@ents.add_edges pts[1],e2)[0]
         @ents.add_face( @ed1.all_connected) if not @face.empty?

         @fillet = true
      end
      #UI.messagebox text
   end


end


##添加菜单
if( not file_loaded?("Fillet.rb") )
   #添加下拉菜单项目
   #UI.menu("Plugins").add_item("Fillet") { Sketchup.active_model.select_tool Fillet.new }
   #添加右键菜单项目
   #UI.add_context_menu_handler do | menu |
   #  if Sketchup.active_model.selection
   #    menu.add_separator
   #    menu.add_item("Fillet") { Sketchup.active_model.select_tool Fillet.new }
   #  end
   #end
end
file_loaded("Fillet.rb")
