###---------------------------------------------------------------------
#	  Name: Hidden2Layer.rb
#   Description: Plugins > Hidden to Layer...
#   Author: TIG (c) 2008
#   Usage:  Put this file into the Plugins Folder.
#     To run on just a Selection pick something first...
#     Otherwise it works on the whole of the Model...
#			Pick "Hidden to Layer" off Plugins Menu...
#			Any Hidden Entities are moved to Layer HIDN***
#     Hidden Entities that are inside of Groups or Component
#     Definitions are moved too, if they are in Selected OR the whole
#     Model is processed...
#     Remove the # in front of soft/smooth options to include if desired.
#   Version:
#     1.0	20080314	First issue.
#     1.1  20080314  Also processes soft/smoothed lines,
#                    and all made 'normal' and HIDN 'off'
#     1.2  20080318  Reverted to hidden onto HIDN (off) only
#                    Also mines groups/defs, moves hidden too...
###---------------------------------------------------------------------
require 'sketchup.rb'
###---------------------------------------------------------------------
class Hiden_layer
   if !defined?(@@hidn) or @@hidn.class!="Sketchup::Layer" or @@hidn.deleted?
      @@hidn=Sketchup.active_model.layers.add("HIDEN")
   end

   def Hiden_layer.hidden2layer
      p "hidden2layer"
      model=Sketchup.active_model
      model.start_operation("Hidden to Layer")
      Sketchup.active_model.selection.each{|e|
         value = e.set_attribute "sutool", "origin_layer", e.layer.name
         e.layer=@@hidn #; e.hidden=false
      }
      @@hidn.visible=false
      Sketchup.active_model.selection.clear
      model.commit_operation
   end#def
   def Hiden_layer.back2layer
      p "back2layer"
      model=Sketchup.active_model
      model.start_operation("Back to Layer")
      Sketchup.active_model.selection.each{|e|
         layer = e.get_attribute "sutool", "origin_layer"
         layer = "Layer0" if !layer
         e.layer=Sketchup.active_model.layers.add(layer)
      }
      Sketchup.active_model.selection.clear
      model.commit_operation
   end#def
   def Hiden_layer.go
      if !defined?(@@hidn) or @@hidn.class!="Sketchup::Layer" or @@hidn.deleted?
         @@hidn=Sketchup.active_model.layers.add("HIDEN")
      end
      if ctrl?
         @@hidn.visible=true;return
      end
      if shift?
         Hiden_layer.back2layer;return
      end
      Hiden_layer.hidden2layer
   end
end
