# Name :          hide_faces_edges.rb
# Description :   Hide and/or unhide faces and/or edges of the current selection
# Author :        Didier Bur
# Usage :         Select objects, select Selection:Hide/Unhide from the Context menu
# Type :          tool
# History:        2004,11,12
#-----------------------------------------------------------------------------
def unselect_selected_edges
model = Sketchup.active_model
ss = model.selection
model.start_operation "Selection: unSelect edges"
ss.each {|e| 
if e.typename == "Edge" 
  ss.remove e
end
}
model.commit_operation
end

def unselect_selected_faces
model = Sketchup.active_model
ss = model.selection
model.start_operation "Selection: unSelect faces"
ss.each {|e| 
if e.typename == "Face" 
  ss.remove e
end
}
model.commit_operation
end


=begin
if( not file_loaded?("UnSelectHIDE_FACES_EDGES.RB") )
   UI.add_context_menu_handler do |menu|
      menu.add_separator
      menu.add_item("Unselect edges") { unSelect_selected_edges }
      menu.add_item("Unselect faces") { unSelect_selected_faces }
     
  end
end
=end
#-----------------------------------------------------------------------------
file_loaded("UnSelectHIDE_FACES_EDGES.RB")

