# Copyright 2005, @Last Software, Inc.

# This software is provided as an example of using the Ruby interface
# to SketchUp.

# Permission to use, copy, modify, and distribute this software for
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
# Authoer : wikii
# Date    : 20100811
#
require 'sketchup.rb'
module Wikii_Tools
   class Double_pitch_roof
      def initialize
         $mm.start_operation "Double_pitch_roof"
         $ss.each{|f|
            next if f.typename!="Face"

            if check_face( f )

               building_up f

            else
               next

            end
         }
         $mm.commit_operation
      end

      def check_face f
         edge_length=f.edges.map{|x| x.length}
         #edge_length[0]==edge_length[2] and edge_length[1]==edge_length[3] and (f.edges[0].line[1].angle_between(f.edges[1].line[1])-Math::PI/2).abs<1e-4
         f.edges.length>=4  #and f.area>(3.m*5.m)

      end

      def rand_between x,y
         srand(rand(12345789))
         x+(y-x)*rand
      end

      def anlyse edges

         max=-1
         n=-1
         0.upto(edges.length-1){|i|
            l=edges[i].length
            if l>max
               max=l
               n=i
            end
         }




         a=edges[n+1-edges.length].length > edges[n-1].length ? edges[n+1-edges.length]  :  edges[n-1]
         b=edges[n]



         base = (a.vertices&b.vertices)[0]
         pa=a.other_vertex(base)
         pb=b.other_vertex(base)


         base=base.position
         pa=pa.position
         pb=pb.position

         va=pa-base
         vb=pb-base

         #~ vz=va*vb
#~ $va=va
#~ $vb=vb

vz=Geom::Vector3d.new 0,0,1


         t1=Geom::Transformation.rotation base, vz, Math::PI/2
         va1=vb.transform(t1)

         t1=Geom::Transformation.rotation base, vz, Math::PI/2*3
         va2=vb.transform(t1)


         v=va.angle_between(va1)< va.angle_between(va2) ? va1 : va2
         v.length=(pa-base).length

         [a,b,base,base+v,pb-base]
      end

      def building_up f
$f=f
         ea,eb,sp,ep,dir=anlyse(f.edges)
p 1
         if ea.length<=3.m
            return
         end


         width=ea.length
         length=eb.length



         vz=Geom::Vector3d.new( 0,0,3.3.m*(rand > 0.95 ? rand_between(1.8,2.2) : rand_between(0.8,1.2)))

         szp=sp+vz
         ezp=ep+vz


         vz.length=width/3

         mzp=Geom::Point3d.new((szp[0]+ezp[0])/2,(szp[1]+ezp[1])/2,(szp[2]+ezp[2])/2)+vz


         #ܾ B
         v1=szp-mzp
         v1.length=v1.length+500.mm*rand_between(0.8,1.2)
         szyp=mzp+v1

         v1=ezp-mzp
         v1.length=v1.length+500.mm*rand_between(0.8,1.2)
         ezyp=mzp+v1
         #ܾ E

         #ɽ B
         dx=dir.clone
         chushanjuli= rand > 0.85 ? 30.mm : 300.mm*(rand_between(0.8,1.2))
         dx.length=-chushanjuli
         #ɽ E

         #ܿڸ߶ B
         dz=vz.clone
         dz.length=200.mm*rand_between(0.8,1.2)
         #ܿڸ߶ E
         building=$ee.add_group

         block=building.entities.add_group


         face=block.entities.add_face sp,szp,mzp,ezp,ep


         if face.normal.angle_between(dir)>Math::PI/3
            face.reverse!
         end
         face.material="white"


         #~ path=building.entities.add_line(sp,sp+dir)
         #~ face.followme path
         face.pushpull length

         roof=building.entities.add_group
         face=roof.entities.add_face szyp+dx,szyp+dz+dx,mzp+dz+dx,ezyp+dz+dx,ezyp+dx,mzp+dx


         if face.normal.angle_between(dir)>Math::PI/3

            face.reverse!
         end
         face.material="dimgray"
         dir.length=dir.length+1200.mm
         #~ path=roof.entities.add_line(szyp+dx,szyp+dx+dir)
         #~ face.followme path

         face.pushpull length+chushanjuli*2

      end

   end # end of class ToolTests
end
#~ # Add a menu choice for tooltests
begin
   if defined?(Sutool)
      eval "def wikii_tools_Double_pitch_roof
      Wikii_Tools::Double_pitch_roof.new
   end"
else
   1/0
end
rescue
if( not file_loaded?("Double_pitch_roof.rb") )
   if !$wikii_tools_menu
      $wikii_tools_menu=UI.menu("Plugins").add_submenu("Wikii Tools")
      $wikii_tools_menu.add_item("Contact_Me") {UI.openURL  "mailto:Wikii2008@gmail.com"}
      $wikii_tools_menu.add_separator
      $wikii_tools_menu_count=0
   end
   if $wikii_tools_menu_count!=0 and ($wikii_tools_menu_count%3)==0
      $wikii_tools_menu.add_separator
   end
   $wikii_tools_menu.add_item("Double_pitch_roof") { Wikii_Tools::Double_pitch_roof.new }
   $wikii_tools_menu_count+=1
end
end
file_loaded("Double_pitch_roof.rb")
__END__
clear
wikii_tools_Double_pitch_roof
