# mx_hidemanager.rb (C) 2010 by Henry Schorradt, info@simkea.de, http://www.simkea.de

##################################################################################
# Legend:
# * -> Security Fix 
# # -> Bug Fix 
# + -> Addition 
# ^ -> Change 
# - -> Removed 
# ! -> Note 
# Changelog:
# 
#
##################################################################################

Sketchup::require 'sketchup.rb'
Sketchup::require 'extensions.rb'

$mxhm_filename=File.basename(__FILE__) 
$mxhm_path=File.dirname(__FILE__)
$mxhm_dialogpath = File.join ( $mxhm_path, "mx_hidemanager","webdialog")
$mxhm_plugin_loader = nil

class MX_hidemanager_loader

	def initialize
		@hm_toolbar = nil
		@hm_tool = nil
	end

	def setHmTool(obj)
		@hm_tool = obj
	end
	
	def setViewWindowButton
		@hm_toolbar = UI::Toolbar.new("Hidden Manager")
        cmd = UI::Command.new("Hidden Manager")	{ @hm_tool.openViewWindow() }
        cmd.small_icon		= File.join("mx_hidemanager", "icons", "mx_viewer.png")
        cmd.large_icon		= File.join("mx_hidemanager", "icons", "mx_viewer.png")
        cmd.status_bar_text	= "Hidden Manager"
        cmd.tooltip			= "Hidden Manager"
		@hm_toolbar.add_item(cmd)

	end
	
	def setViewWindowEntry
		parent_menu = UI.menu("Plugins")
		parent_menu.add_item("Hidden Manager") { @hm_tool.openViewWindow() }
	end
	
end # class

#-----------------------------------------------------------------------------
if( not file_loaded?(__FILE__) ) then
	$mxhm_plugin_loader = MX_hidemanager_loader.new
	mx_hiddenmanager = SketchupExtension.new "Hidden Manager", File.join ("mx_hidemanager","MX_hidemanager.rbs")
	mx_hiddenmanager.name = "Hidden Manager"
	mx_hiddenmanager.version = "1.0.0"
	mx_hiddenmanager.description = "Contact: info@simkea.de (german)"
	mx_hiddenmanager.copyright = "Henry Schorradt, info@simkea.de"
	mx_hiddenmanager.creator = "Henry Schorradt"
	Sketchup.register_extension mx_hiddenmanager, true
end
file_loaded(__FILE__)
