# Copyright 2006 TBD / plugins.ro 

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

# Name :          Centroid 1.0
# Description :   add a cpoint at gravity center for a 2D face 
# Author :        TBD
# Date :          26.Sep.2006
# Type :          tool
# History:        1.0 (26.Sep.2006) - first version

require 'sketchup.rb'

class Centroid
  def self.go(f=Sketchup.active_model.selection.first)
    #f = Sketchup.active_model.selection[0]
    a = f.area 
    v = f.vertices.map {|x| x.position.to_a}
    
    cx = cy = 0
    cz = 0
    
    n = v.length
    for i in 0..n-1
      j = (i + 1) % n
      second = (v[i].x * v[j].y) - (v[j].x * v[i].y)
      cx += (v[i].x + v[j].x) * second
      cy += (v[i].y + v[j].y) * second
      cz += v[i].z
    end
    
    cx = cx / 6.0 / a
    cy = cy / 6.0 / a
    cz = cz / n
    
    #Sketchup.active_model.active_entities.add_cpoint [cx, cy]
    Geom::Point3d.new( cx, cy, cz )
  end
end
  
#if( not file_loaded?("centroid.rb") )
#  centroid_menu = UI.menu("Plugins").add_item("[TBD] Centroid") {Centroid.go}
#end

#file_loaded("centroid.rb")
