class Float
  def approx(other, relative_epsilon=Float::EPSILON, epsilon=Float::EPSILON)
    difference = other - self
    return true if difference.abs <= epsilon
    relative_error = (difference / (self > other ? self : other)).abs
    return relative_error <= relative_epsilon
  end
end

module SK
  def SK::corner_vertices(face)
    face_edges = face.edges
    verts = face.outer_loop.vertices
    shared = []
    verts.each_with_index do |v, i|
      v_edges = v.edges
      edges = v_edges & face_edges
      line1 = edges[0].line
      line2 = edges[1].line
      vec1 = line1[1]
      vec2 = line2[1]
      ab = (vec1.angle_between vec2).abs.radians
      if ab.approx(180) or ab.approx(0)
	shared << v
      end
    end
    return [verts - shared].flatten
  end
end
