require 'sketchup'

# Oooh, named selection sets!
# Selection filters: faces only, edges only, et.
# Model Observer onTransactionUndo goes here?

class SelectionManager

  def initialize
    @ss = Sketchup.active_model.selection
    @stack = []
    @ptr = 0
    @namedSets = {}
  end

  def active_selection
    @ss
  end

  def set
    @tmp2 = @ss.select{ |e| e.typename == "Face" }
    @ss.clear
    @ss.add @tmp2
  end

  def 

  def store
    @stack = @ss.to_a
    @tmp = @ss.to_a
  end

  def restore
    if @tmp2 && @tmp2.length > 0
      @ss.clear
      @ss.add(@tmp2)
    end
  end

  def save(name = nil)
    @stack.push(@ss.collect{|e| e.entityID})
    if name
      @namedSets[name] = @stack.last
    end
    @ptr = @stack.length - 1
  end

  def recall(name = nil)
    if name
      setSelection @namedSets[name]
    else
      setSelection @stack.last
    end
  end

  def pop
    @stack.pop
    if @ptr > @stack.length - 1
      @ptr -= 1
    end
  end

  def undo?
    @stack.length > 0
  end

  def undo(flag = false)
    if undo?
      if flag
	Sketchup.undo
	UI.start_timer(1) { setSelection(@stack.pop) }
      else
	setSelection(@stack.pop)
      end
    end
  end

  def reset
    @stack.clear
    @ptr = 0
  end

  def setSelection(ids)
    things = []
    Sketchup.active_model.active_entities.each {|e|
      st =  ids.include? e.entityID
      things.push e if st
    }
    #puts "things:#{ things.inspect}"
    @ss.clear
    @ss.add things
    #puts self.inspect
  end

  def lastWith(id)
  end

  def current
    "@stack.last = #{@stack.last.inspect}"
  end


  def clear
    @stack.clear
  end

  def active
    @ss.to_a
  end

  def count
    @stack.length
  end

  def rando
    active.sort_by!{ rand }
  end

  def save2
    @tmp = active_faces
  end

  def shuffle(v)
    @tmp = @tmp2.sort_by{ rand }
    reduce(v)
  end


  def reduce(percent)
    return if @tmp.nil? or @tmp[0].nil?

    Sketchup.active_model.selection.clear
    n = percent / 100.0 * @tmp.length
    #p n
    Sketchup.active_model.selection.add @tmp[0, n]
  end

  def active_faces
    active.select{|e| e.typename=="Face"}
  end

  def dump
    @stack.each_with_index do |e, i|
      puts "#{i}:#{e.inspect}"
    end
  end

  def select(entities = nil)
    if entities.nil?
      @ss.clear
    else
      @ss.add(entities)
    end
  end

end
